function [U,V,W] = wirePlanField_vector(r, M, B_0, X, Y, supMagParams)
%%% Calcul du champ de fuite d'un fil en tout point de l'espace.
% L'aimantation est uniforme dans le fil
%
%
% $Revision: 15 $
% $Author: lenertz $
% $Date: 2015-07-30 17:36:07 +0200 (jeu., 30 juil. 2015) $


    %mu_0  = 4 * pi * 1e-7;
    %global mu_wire
    

    %H = M / mu_0;
    % Champ mag forcément selon x
    %B_abs = norm(M);
    % fonction de rotation du reférenciel à rajouter
    %angle = atan2(norm(cross([1,0,0],H)),dot([1,0,0],H));
    
    % if x is given as an array an not y or the opposit
    if numel(X) ~= numel(Y); 
        if numel(Y) == 1;
            y = Y;
            Y = X;
            Y(:) = y;
        elseif numel(X) == 1;
            x = X;
            X = Y;
            X(:) = x; 
        end
    end
    
    % initialisation des matrices de champs
    U = X;
    U(:)=0;
    V = U;
    W = U;
    U_temp = U;
    V_temp = U;
    
    % On cherche les positions dans et hors du fil
    position_r = (X.^2 + Y.^2).^(1/2);
    in_position = find(position_r <= r);
    out_position = find(position_r > r);
    
    % Dans le fil
    U(in_position) = M(1);
    V(in_position) = M(2);
    W(in_position) = M(3);
    
    
    % Hors du fil
    % On calcule d'abord dans un repère ou le champ Mxy est selon x
    U_temp(out_position) = (X(out_position).^2 - Y(out_position).^2) .* norm(M(1:2))*(r^2) ./ ((X(out_position).^2 + Y(out_position).^2).^2);
    V_temp(out_position) = 2 .* X(out_position) .* Y(out_position) .* norm(M(1:2))*(r^2) ./ ((X(out_position).^2 + Y(out_position).^2).^2);
    % puis on procède à un changement de base
    theta = atan2(M(2),M(1)); % angle entre le champ M dans le plan xy avec l'axe x
    U(out_position) = cos(theta) * U_temp(out_position) + sin(theta) * V_temp(out_position);
    V(out_position) = cos(theta) * V_temp(out_position) - sin(theta) * U_temp(out_position); 
    
    % On ajoute le champ appliqué
    U = U + B_0(1);
    V = V + B_0(2);
    W = W + B_0(3);
end